/*
Copyright 2007 Guillaume Hanrot, Vincent Lefèvre, Damien Stehlé 
and Paul Zimmermann.

  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public 
  License along with this program; see the file COPYING.  If not, 
  write to the Free Software Foundation, Inc., 59 Temple Place - 
  Suite 330, Boston, MA 02111-1307, USA.
*/

#define NAME "oneoverx" 
#define EVAL(y, rnd_mode) mpfr_ui_div(y, 1, y, rnd_mode); 
#define BNDDIFF(tmp, t0, t1, N){         \
  if (mpz_sgn(t0)>0){                    \
    mpfr_set_z (tmp, t0, MPFR_RNDU);      \
    mpfr_div (tmp, tmp, Nin, MPFR_RNDD);  \
  }                                      \
  else{                                  \
    mpfr_set_z (tmp, t1, MPFR_RNDD);      \
    mpfr_abs (tmp, tmp, MPFR_RNDU);       \
    mpfr_div (tmp, tmp, Nin, MPFR_RNDD);  \
  }                                      \
  mpfr_ui_div (tmp, 1, tmp, MPFR_RNDU);   \
  mpfr_pow_ui (tmp, tmp, d+2, MPFR_RNDU); \
  for (i=1; i<=d+1; i++)                 \
    mpfr_mul_ui (tmp, tmp, i, MPFR_RNDU); \
}

#define TAYLOR(tmp, tm, Nin, P, NN, d)		\
  { long i;					\
    mpfr_set_z (tmp, tm, MPFR_RNDN);		\
    mpfr_div (tmp, tmp, Nin, MPFR_RNDN);		\
    mpfr_ui_div (tmp, 1, tmp, MPFR_RNDN);	\
    mpfr_mul (P[0], tmp, NN, MPFR_RNDN);		\
    for (i=1; i<=d; i++) {			\
      mpfr_mul_si (P[i], P[i-1], -1, MPFR_RNDN);	\
      mpfr_mul_z (P[i], P[i], T, MPFR_RNDN);	\
      mpfr_div (P[i], P[i], Nin, MPFR_RNDN);	\
      mpfr_mul (P[i], P[i], tmp, MPFR_RNDN);	\
    }						\
  }
